Subject: [bug#51428] core-updates-frozen-batched-changes built and ready to merge

From: Thiago Jung Bauermann <[email-masked]>
Date: Wed, 27 Oct 2021 13:26:37 -0300

Hello Maxim,

Em quarta-feira, 27 de outubro de 2021, às 12:37:21 -03, Maxim Cournoyer escreveu:
> Thiago Jung Bauermann <[email-masked]> writes:
> > Em quarta-feira, 27 de outubro de 2021, às 01:04:01 -03, Maxim Cournoyer escreveu:
> >> I'd like to merge it into core-updates-frozen by the beginning of
> >> November, unless there are problems you can spot :-).
> > 
> > I wouldn’t say it’s a problem but it’s an additional significant change
> > to be aware of:
> > 
> > polkit is updated to depend on mozjs-78, which depends on Rust which
> > only builds on x86_64. The practical consequence is that polkit and
> > all its dependents (which include GTK+ and some Qt libraries) become
> > x86_64-only packages. I’m not saying it’s a problem, but it’s a big
> > change and I thought it would beuseful to mention it.
> > 
> > I discovered this yesterday night when playing a bit with the
> > core-updates-frozen- batched-changes branch on ppc64le.
> 
> Good observation!  Did rust ended up building and working fine there?

It didn’t. mrustc builds, but when rust’s build phase tries to use it,
mrustc errors out:

--8<---------------cut here---------------start------------->8---
bin/minicargo rustc-1.39.0-src/src/libstd --vendor-dir rustc-1.39.0-src/vendor --script-overrides script-overrides/stable-1.39.0-linux/ --output-dir output/ -j8 --manifest-overrides rustc-1.39.0-overrides.toml
> /tmp/guix-build-rust-1.39.0.drv-0/mrustc/bin/mrustc -Z print-cfgs
Unknown target name ''
Process was terminated with signal 6
EXCEPTION: Unable to invoke compiler to get config options
make: *** [minicargo.mk:82: output/libstd.rlib] Error 1
--8<---------------cut here---------------end--------------->8---

> I'm hoping that with the reduced Rust bootstrap chain that starts with
> 1.39 and uses newer components, it may finally be more accessible to
> other architectures.

There’s an unmerged PR for mrustc adding support for ppc64 but I haven’t
tried it:

https://github.com/thepowersgang/mrustc/pull/159[1]

Accessing the link now, I see that someone reported being able to bootstrap
rustc 1.29 on powerpc64le-linux with it!  \o/

I’ll try it out within the next couple of days and send a patch if it works.

> > This may be a temporary limitation, because there are two pull requests
> > for polkit replacing mozjs with duktape:
> > 
> > https://gitlab.freedesktop.org/polkit/polkit/-/merge_requests/35[1]
> > https://gitlab.freedesktop.org/polkit/polkit/-/merge_requests/97[2]
> 
> Good to know!

And duktape builds on ppc64le. :-)

Changing subjects a bit: I forgot to report in my last email that I tested:

$ guix pull --url=$HOME/src/guix \
	--branch= core-updates-frozen-batched-changes

on powerpc64le-linux and it worked. Well, almost. It did when I included
the mariadb patch from https://issues.guix.gnu.org/51376[2] (which is already
in core-updates-frozen).

-- 
Thanks,
Thiago

--------
[1] https://github.com/thepowersgang/mrustc/pull/159
[2] https://issues.guix.gnu.org/51376